import pygame
from image import im
from sound import sm

class Actor:

	def __init__(self,pos,img,path,deathTime=None):
		self.img = im.get(img)
		self.imgname = img
		self.pos = list(pos)
		self.path = path
		self.dx = self.dy = 0
		self.alive = True
		if deathTime:
			self.minDeathTime = deathTime[0]
			self.maxDeathTime = deathTime[1]
			self.timelyDeath  = False
		else:
			self.minDeathTime = self.maxDeathTime = -1
			self.timelyDeath = True
	
	def tick(self):
		if not self.alive:
			return
		if len(self.path):
			wp = self.path[0] #WayPoint
			#calculate vector
			if self.dx == self.dy == 0:
				dx = wp[0] - self.pos[0]
				dy = wp[1] - self.pos[1]
				norm = (dx**2 + dy**2)**.5
				self.dx = dx/norm
				self.dy = dy/norm
			#move towards next waypoint
			self.pos[0] += self.dx
			self.pos[1] += self.dy
			#check for arrival
			if ((wp[0]-self.pos[0])**2 + (wp[1]-self.pos[1])**2) < 4:
				self.path.pop(0)
				self.dx = self.dy = 0
	
	def kill(self,time):
		if self.alive:
			self.alive = False
			sm.play("snip.ogg")
			self.img = im.get("dead%s"%self.imgname)
			if self.minDeathTime < time < self.maxDeathTime:
				self.timelyDeath = True
			else:
				self.timelyDeath = False

	
	def render(self,screen):
		screen.blit(self.img,[self.pos[0]-10,self.pos[1]-10])